/*
 edit.c - Main source file of SimpleEdit
 Date: 04/2000
 Author: maC (mac_mac@gmx.net)
 License: GPL
 Version: 0.3
*/

/*
TO DO:
   * Print cursor position at topright of window
OK * processlilnes: fehler in statusleiste
OK * SPEICHERN
   * Markieren, einfgen, kopieren, ausschneiden
   * Tastaturhandler
     => Zahlen
     => ASCII Zeichen mittels ALT-Taste
   * Tools:
	     => Commandline-Befehl ausfhren
     => ASCII Tabelle anzeigen
   * Auch als HEX-Editor funktionieren lassen
   * Eingabemodus "berschreiben" eincoden
   * Suchfunktionen
   * in EnterString: abbrch mit ESC: alten file_name wiederherstellen ?
*/

#include "v2os.h"
#include "edit.h"

/****** LINE AND TEXT MEMORY BUFFERS **************/
int LB_ptr;
int LB_size;

int TB_size;
int TB_ptr;

/******* LINE AND TEXT INFORMATIONS ****************/
#define MaxLines (8192)
int line_count;

#define SecurityDistance (32)

int text_size;
int text_style; //0=DOS, 1=UNIX

int Mark_Start_Line;
int Mark_Start_Pos;
int Mark_End_Line;
int Mark_End_Pos;

/******* FILE INFORMATION **************/
char file_name[100] = "";
int file_disk;
int file_data_start;
int file_sector_count;
int file_attributes;
int file_rawlength;


/******* DISKBUFFER INFORMATION ************/
int DB_size=0;
int DB_offs=0;


/******* WINDOW DISPLAY INFORMATION ****************/
int w_x,w_y,w_w,w_h;	// Screenposition of text-window
int t_x,t_y;	// Position of Text inside the Window
int c_x,c_y;	// Position of Cursor inside the Text

char* Status_text="-";
int Status_color=0;

#define status_color_error (0+16*6)
#define status_color_normal (1+16*4)

int ScreenSaver;
int ScreenSaverSize;

/********** TEXT AND LINE BUFFER ACCSSES ******************/
#define GetLineStart(a) peekl(0x18,((a)<<3)+LB_ptr)
#define GetLineLength(a) peekl(0x18,((a)<<3)+LB_ptr+4)
#define SetLineStart(a,b) pokel(0x18,((a)<<3)+LB_ptr,b)
#define SetLineLength(a,b) pokel(0x18,((a)<<3)+LB_ptr+4,b)

#define GetChar(a) peekb(0x18,TB_ptr+(a))
#define SetChar(a,b) pokeb(0x18,TB_ptr+(a),b);

void inline PutChar (int x, int y, char c, int col)
{
	pokeb( 0x18, 0xB8000+  ((x+y*80)<<1), c );
	pokeb( 0x18, 0xB8000+1+((x+y*80)<<1), col );
}

void Window( int x, int y, int w, int h, int col, unsigned char* title, int ScrollBar)
{
	int i,j;

	for( i=x+1; i<x+w; i++ )
	{
		PutChar( i, y, 196, col );
		PutChar( i, y+h, 196, col );
	}
	if( ScrollBar==0 ) j=179; else j=186;
	for( i=y+1; i<y+h; i++)
	{
		PutChar( x, i, 179, col);
		PutChar( x+w, i, j, col); //scroll-bar
	}
	PutChar( x, y, 218, col );
	PutChar( x+w, y, 191, col );
	PutChar( x, y+h, 192, col );
	PutChar( x+w, y+h, 217, col );
	i=v2_strlen(title);

		//Print Title (if any)
	if( i>0 )
	{
		PutChar( x+2, y, ' ', col);
		for( j=0; j<i; j++ )
			PutChar(x+3+j, y, *title++, col);
		PutChar( x+3+j, y, ' ', col);
	}

		// Print Cursor position

		// Scroll-Bar
	if( ScrollBar==1 )
	{
		PutChar( x+w, y+1, 197, col );
		PutChar( x+w, y+h-1, 197, col );
	}
}

void SetScrollBar( int x, int y, int w, int h, int col, int pos, int max )
{
	int v;		// = ((h-4)*(pos))/(max-1);	// pos<max!!, pos[0] = 0!!
/*	if( (max-1)==0 ) v=0;
		else v=((h-4)*(pos))/(max-1);
*/
	if( max==0 ) v=0;
	else v=((h-4)*(pos))/max;
	if( v>h-4 ) v=h-4;
	PutChar( x+w, y+2+v, 219, col );
}

#include "Textuse.c"
#include "FileIO.c"
#include "memman.c"
#include "menu.c"

int main(void)
{
	term_puts( SCR_DEBUG, "\r\n=== SimpleEdit starting here ===\r\n" );

	puts("V2_SimpleEdit       v0.3 (beta)       4/2000        (c) maC \r\n\r\n");

	GetMemory( 1024 );
	Text_New();

	 term_puts( SCR_DEBUG, "Starting DisplayLoop()...\r\n");
	InitDisplay();
	MakeMenu();
	RestoreDisplay();

	puts("\r\n\r\n");

	term_puts( SCR_DEBUG, "=== SimpleEdit ending here ===\r\n" );
	return 0;
}
