typedef struct {
	int EntryCount;
	char* Entrys[4];
	int BiggestEntry;
	int EntrySizes[4];
} tMenu;

/*
tMenu menu[5] = {
	{ 4, {" File", " Search", " Tools", " Help" } }, //, {5, 7, 6, 5}
	{ 4, {" New text", " Open file", " Save as...", " Exit SimpleEdit" } },
	{ 2, {" Search for...", " Search again" } },
	{ 1, {" Execute shell command"} },
	{ 1, {" About..."} }
};
*/

tMenu menu[3] = {
	{ 2, {" File", " Tools" } }, //, {5, 7, 6, 5}
	{ 4, {" New text", " Open file", " Save as...", " Exit SimpleEdit" } },
//	{ 2, {" Search for...", " Search again" } },
	{ 1, {" Execute shell command"} },
//	{ 1, {" About..."} }
};


char tool_buffer[100];

void ProcessMenus()
{
	int i,j;
	for( i=1; i<=menu[0].EntryCount; i++)
	{
		menu[i].BiggestEntry=0;
		for( j=0; j<menu[i].EntryCount; j++ )
			if( v2_strlen(menu[i].Entrys[j])>menu[i].BiggestEntry)
				menu[i].BiggestEntry = v2_strlen(menu[i].Entrys[j]);
	}
}

void DisplaySubMenu(int x, int y, int menuNR, int marked)
{
	int i;
	int col;
	int size;

	Window( x, y, menu[menuNR].BiggestEntry+3, menu[menuNR].EntryCount+1, 15+16*8, "", 0 );

	for( i=0; i<menu[menuNR].EntryCount; i++ )
	{
		if(i==marked) col=2+16*5; else col=1+16*8;

		size=v2_strlen(menu[menuNR].Entrys[i]);

		LineOut( menu[menuNR].Entrys[i], y+1+i, col, x+1, menu[menuNR].BiggestEntry+1);
	}
}

void DisplayMainMenu(int marked, int markedsub)
{
	int i;
	int col;
	int pos=2;
	int size;

	for( i=0; i<menu[0].EntryCount; i++ )
	{
		if(i==marked) col=2+16*5; else col=1+16*15;

		size=v2_strlen(menu[0].Entrys[i]);

		LineOut(menu[0].Entrys[i], 55, col, pos, size);

		if(i==marked) DisplaySubMenu(pos, 0, i+1, markedsub);
		pos+=size+1;
	}
}

void Error(char* errstr)
{
	Status_text = errstr;
	Status_color = status_color_error;
	Display(1);
	getkey();

	Status_color = status_color_normal;
	Status_text = "";
	Display(0);
}

void Tools_Run()
{
	RestoreDisplay();
	
	puts("\r\n WARNING: This is still an experimental feature, handle with care!\r\n");
	puts(" Please enter the shell-command that should be executed: ");
	gets(&tool_buffer[0]);
	puts("\r\n");
	
	shell_command(&tool_buffer[0]);

	puts("\r\n");
	puts(" <-- Press any key to return to SimpleEdit -->");
	getkey();
	puts("\r\n");
	InitDisplay();
	Display(1);
}

int EnterString(char* title, char* status, char* buffer)
{
	int length; //, pos
	unsigned char c;
	char* bufpos = buffer;

	Status_text = status; //" Please enter a Filename or press ESC to cancel operation";
	Status_color = status_color_normal;

	Display(1);

	Window( 20, 21, 40, 2, 15+16*8, title, 0 );	
	
//	pos=0;
	length=0;
//	file_name[0]=0;
	*buffer=0;

	for(;;)
	{
		//LineOut( &file_name[0], 22, 15+16*8, 21, 38 );
		LineOut( buffer, 22, 15+16*8, 21, 38 );
		c='*';
		PutChar( 21+length, 22, c, 0+16*2 );

		c=getkey();
//		if( (c>31)&(c<128) ) {file_name[pos]=c; pos++; length++; file_name[length]=0; }

		if( (c>31)&(c<128) ) {*bufpos=c; bufpos++; length++; *bufpos=0; }
		else
		switch(c)
		{
			case 8: if(length>0) {bufpos--; length--; *bufpos=0; }
				break;
			case 27: getkey(); return 0;
		}
		if(c==13) break;
		if(length>38) {bufpos--; length--; }
	}

	return 1;
}

/*
char SearchString[40];

void Text_Search()
{
	int i,j;
	if( 0==EnterString( "Search for", " Enter String to search for, press ESC to cancel", &SearchString[0] ) )
		return;
	// TODO!
}
*/

void Text_Save()
{
	if( 0==EnterString("Save File", " Enter filename or press ESC to cancel", &file_name[0]) ) return;

	if( GetFileInfo()==1 )
	{
		Error(" File already exists, cannot overwrite files! (Press any key to continue)");
		return;
	}

	if( 0!=CreateFile( text_size ) )
	{
		Error(" Error while creating file! (Press any key to continue)");
		return;
	}

	if( GetFileInfo()!=1 )
	{
		Error(" Error: Couldn't find created file! (Press any key to continue)");
		return;		
	}
	if( (text_size/512)+1 != file_sector_count )
	{
		Error(" Error: File size mismatch! (Press any key to continue)");
		return;		
	}

	SaveFile();
}


void Text_New()
{
	line_count=1;
	text_size=1;
	text_style=0;

	SetLineLength(0, 0);
	SetLineStart(0, 0);

	c_x=0;
	c_y=0;
	file_name[0]=0;

	SetChar(0, 0);
	SetChar(1, 0);
}

void Text_Load()
{
	if( 0==EnterString("Open File", " Enter filename or press ESC to cancel", &file_name[0]) ) return;

	if( GetFileInfo()!=1 )
	{
		Error(" File not found error! (Press any key to continue)");
		Text_New();		
		return;
	}

	if( file_rawlength+SecurityDistance>TB_size )
		AllocAdditionalBuffer( file_rawlength+SecurityDistance-TB_size );

	LoadFile();
	ProcessLines();

	c_x=0;
	c_y=0;
}

int ProcessCommand(int mx, int my)
{
	switch(mx*16+my)
	{
	case 0x00 :
		Text_New();
		return 1; //new
	case 0x01 :
		Text_Load();
		return 1;
	case 0x02 :
		Text_Save();
		return 1;
	case 0x03 : 
		return 0; //quit

/*	case 0x10 : //Search
		Text_Search();
		return 1;
*/
	case 0x20 :
		Tools_Run();
		return 1;
	}
	return 2; //?? error??
}

void MakeMenu()
{
	int mx=0, my=0;
	int endmenu;
	char c;

	ProcessMenus();

	for(;;)
	{
		switch( DisplayLoop() )
		{
		case 'f':
		case 'F': mx=0; break;
		case 't':
		case 'T': mx=1; break;
		default : mx=0; break;
		}

		my=0;
		endmenu=0;
		
		while( endmenu==0 )
		{
			Display(0);
			DisplayMainMenu(mx,my);
			c=getkey();
			switch(c)
			{
			case '2': my=(my+1)%menu[mx+1].EntryCount; break;
			case '8': my=(my-1+menu[mx+1].EntryCount)%menu[mx+1].EntryCount; break;
			case '4': mx=(mx-1+menu[0].EntryCount)%menu[0].EntryCount; my=0; break;
			case '6': mx=(mx+1)%menu[0].EntryCount; my=0; break;
			case 13 : if( ProcessCommand( mx, my )==0 ) return;
				endmenu=1;
				break;
			case 27 : getkey(); // BUGFIX: V2OS returns 2 characters, if ESC is pressed. we have to catch the second
				endmenu=1;
				break;
			} //switch()
		} //while()

	} // for(;;)
}
